'Author: Michael Fischer, 5 BDH, HTL-Donaustadt, Schuljahr 2004/2005
'
'Summary: 
'   - User Interface for Musepaxx.exe
'   - Load/Save of Musepaxx.cfg, settings-file for Musepaxx.exe
'   - Drag&Drop of Musepack-files into the listbox
'   - Calling of Musepaxx.exe for each item in the listbox

'Copyright (C) 2005 Michael Fischer

'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Imports System
Imports System.IO

Public Class MusepaxxGUI
    Inherits System.Windows.Forms.Form

#Region " Vom Windows Form Designer generierter Code "

    Public Sub New()
        MyBase.New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen

    End Sub

    ' Die Form berschreibt den Lschvorgang der Basisklasse, um Komponenten zu bereinigen.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Fr Windows Form-Designer erforderlich
    Private components As System.ComponentModel.IContainer

    'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
    'Sie kann mit dem Windows Form-Designer modifiziert werden.
    'Verwenden Sie nicht den Code-Editor zur Bearbeitung.
    Friend WithEvents btnEnc As System.Windows.Forms.Button
    Friend WithEvents btnTrans As System.Windows.Forms.Button
    Friend WithEvents lbFiles As System.Windows.Forms.ListBox
    Friend WithEvents txtEncLoc As System.Windows.Forms.TextBox
    Friend WithEvents txtDecLoc As System.Windows.Forms.TextBox
    Friend WithEvents gbDecoder As System.Windows.Forms.GroupBox
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents txtDecSet As System.Windows.Forms.TextBox
    Friend WithEvents gbEncoder As System.Windows.Forms.GroupBox
    Friend WithEvents txtEncSet As System.Windows.Forms.TextBox
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents btnDec As System.Windows.Forms.Button
    Friend WithEvents gbMusepaxx As System.Windows.Forms.GroupBox
    Friend WithEvents txtMusepaxx As System.Windows.Forms.TextBox
    Friend WithEvents btnMusepaxx As System.Windows.Forms.Button
    Friend WithEvents btnLoadSettings As System.Windows.Forms.Button
    Friend WithEvents btnSaveSettings As System.Windows.Forms.Button
    Friend WithEvents chDir As System.Windows.Forms.CheckBox
    Friend WithEvents txtDir As System.Windows.Forms.TextBox
    Friend WithEvents Label4 As System.Windows.Forms.Label
    Friend WithEvents txtEncExt As System.Windows.Forms.TextBox
    Friend WithEvents Label5 As System.Windows.Forms.Label
    Friend WithEvents txtDecExt As System.Windows.Forms.TextBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(MusepaxxGUI))
        Me.txtEncLoc = New System.Windows.Forms.TextBox
        Me.btnEnc = New System.Windows.Forms.Button
        Me.btnDec = New System.Windows.Forms.Button
        Me.txtDecLoc = New System.Windows.Forms.TextBox
        Me.btnTrans = New System.Windows.Forms.Button
        Me.lbFiles = New System.Windows.Forms.ListBox
        Me.gbDecoder = New System.Windows.Forms.GroupBox
        Me.txtDecExt = New System.Windows.Forms.TextBox
        Me.Label5 = New System.Windows.Forms.Label
        Me.txtDecSet = New System.Windows.Forms.TextBox
        Me.Label1 = New System.Windows.Forms.Label
        Me.gbEncoder = New System.Windows.Forms.GroupBox
        Me.txtEncExt = New System.Windows.Forms.TextBox
        Me.Label4 = New System.Windows.Forms.Label
        Me.Label2 = New System.Windows.Forms.Label
        Me.txtEncSet = New System.Windows.Forms.TextBox
        Me.Label3 = New System.Windows.Forms.Label
        Me.gbMusepaxx = New System.Windows.Forms.GroupBox
        Me.btnSaveSettings = New System.Windows.Forms.Button
        Me.btnMusepaxx = New System.Windows.Forms.Button
        Me.txtMusepaxx = New System.Windows.Forms.TextBox
        Me.btnLoadSettings = New System.Windows.Forms.Button
        Me.chDir = New System.Windows.Forms.CheckBox
        Me.txtDir = New System.Windows.Forms.TextBox
        Me.gbDecoder.SuspendLayout()
        Me.gbEncoder.SuspendLayout()
        Me.gbMusepaxx.SuspendLayout()
        Me.SuspendLayout()
        '
        'txtEncLoc
        '
        Me.txtEncLoc.Location = New System.Drawing.Point(16, 16)
        Me.txtEncLoc.Name = "txtEncLoc"
        Me.txtEncLoc.Size = New System.Drawing.Size(224, 20)
        Me.txtEncLoc.TabIndex = 0
        Me.txtEncLoc.Text = ""
        '
        'btnEnc
        '
        Me.btnEnc.Location = New System.Drawing.Point(248, 16)
        Me.btnEnc.Name = "btnEnc"
        Me.btnEnc.Size = New System.Drawing.Size(72, 24)
        Me.btnEnc.TabIndex = 1
        Me.btnEnc.Text = "Encoder"
        '
        'btnDec
        '
        Me.btnDec.Location = New System.Drawing.Point(248, 16)
        Me.btnDec.Name = "btnDec"
        Me.btnDec.Size = New System.Drawing.Size(72, 24)
        Me.btnDec.TabIndex = 2
        Me.btnDec.Text = "Decoder"
        '
        'txtDecLoc
        '
        Me.txtDecLoc.Location = New System.Drawing.Point(16, 16)
        Me.txtDecLoc.Name = "txtDecLoc"
        Me.txtDecLoc.Size = New System.Drawing.Size(224, 20)
        Me.txtDecLoc.TabIndex = 3
        Me.txtDecLoc.Text = ""
        '
        'btnTrans
        '
        Me.btnTrans.Location = New System.Drawing.Point(256, 312)
        Me.btnTrans.Name = "btnTrans"
        Me.btnTrans.TabIndex = 6
        Me.btnTrans.Text = "Transcode"
        '
        'lbFiles
        '
        Me.lbFiles.AllowDrop = True
        Me.lbFiles.Location = New System.Drawing.Point(8, 344)
        Me.lbFiles.Name = "lbFiles"
        Me.lbFiles.Size = New System.Drawing.Size(336, 134)
        Me.lbFiles.TabIndex = 8
        '
        'gbDecoder
        '
        Me.gbDecoder.Controls.Add(Me.txtDecExt)
        Me.gbDecoder.Controls.Add(Me.Label5)
        Me.gbDecoder.Controls.Add(Me.txtDecSet)
        Me.gbDecoder.Controls.Add(Me.Label1)
        Me.gbDecoder.Controls.Add(Me.txtDecLoc)
        Me.gbDecoder.Controls.Add(Me.btnDec)
        Me.gbDecoder.Location = New System.Drawing.Point(8, 104)
        Me.gbDecoder.Name = "gbDecoder"
        Me.gbDecoder.Size = New System.Drawing.Size(336, 100)
        Me.gbDecoder.TabIndex = 9
        Me.gbDecoder.TabStop = False
        Me.gbDecoder.Text = "Decoder"
        '
        'txtDecExt
        '
        Me.txtDecExt.Location = New System.Drawing.Point(248, 72)
        Me.txtDecExt.Name = "txtDecExt"
        Me.txtDecExt.Size = New System.Drawing.Size(72, 20)
        Me.txtDecExt.TabIndex = 7
        Me.txtDecExt.Text = ""
        '
        'Label5
        '
        Me.Label5.Location = New System.Drawing.Point(248, 48)
        Me.Label5.Name = "Label5"
        Me.Label5.Size = New System.Drawing.Size(56, 16)
        Me.Label5.TabIndex = 6
        Me.Label5.Text = "Extension"
        '
        'txtDecSet
        '
        Me.txtDecSet.Location = New System.Drawing.Point(16, 72)
        Me.txtDecSet.Name = "txtDecSet"
        Me.txtDecSet.Size = New System.Drawing.Size(224, 20)
        Me.txtDecSet.TabIndex = 5
        Me.txtDecSet.Text = ""
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(16, 48)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(100, 16)
        Me.Label1.TabIndex = 4
        Me.Label1.Text = "Settings"
        '
        'gbEncoder
        '
        Me.gbEncoder.Controls.Add(Me.txtEncExt)
        Me.gbEncoder.Controls.Add(Me.Label4)
        Me.gbEncoder.Controls.Add(Me.Label2)
        Me.gbEncoder.Controls.Add(Me.txtEncSet)
        Me.gbEncoder.Controls.Add(Me.txtEncLoc)
        Me.gbEncoder.Controls.Add(Me.btnEnc)
        Me.gbEncoder.Location = New System.Drawing.Point(8, 208)
        Me.gbEncoder.Name = "gbEncoder"
        Me.gbEncoder.Size = New System.Drawing.Size(336, 100)
        Me.gbEncoder.TabIndex = 10
        Me.gbEncoder.TabStop = False
        Me.gbEncoder.Text = "Encoder"
        '
        'txtEncExt
        '
        Me.txtEncExt.Location = New System.Drawing.Point(248, 72)
        Me.txtEncExt.Name = "txtEncExt"
        Me.txtEncExt.Size = New System.Drawing.Size(72, 20)
        Me.txtEncExt.TabIndex = 5
        Me.txtEncExt.Text = ""
        '
        'Label4
        '
        Me.Label4.Location = New System.Drawing.Point(248, 48)
        Me.Label4.Name = "Label4"
        Me.Label4.Size = New System.Drawing.Size(56, 16)
        Me.Label4.TabIndex = 4
        Me.Label4.Text = "Extension"
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(16, 48)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(100, 16)
        Me.Label2.TabIndex = 3
        Me.Label2.Text = "Settings"
        '
        'txtEncSet
        '
        Me.txtEncSet.Location = New System.Drawing.Point(16, 72)
        Me.txtEncSet.Name = "txtEncSet"
        Me.txtEncSet.Size = New System.Drawing.Size(224, 20)
        Me.txtEncSet.TabIndex = 2
        Me.txtEncSet.Text = ""
        '
        'Label3
        '
        Me.Label3.Location = New System.Drawing.Point(8, 320)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(120, 16)
        Me.Label3.TabIndex = 11
        Me.Label3.Text = "Drag your files here:"
        '
        'gbMusepaxx
        '
        Me.gbMusepaxx.Controls.Add(Me.btnSaveSettings)
        Me.gbMusepaxx.Controls.Add(Me.btnMusepaxx)
        Me.gbMusepaxx.Controls.Add(Me.txtMusepaxx)
        Me.gbMusepaxx.Controls.Add(Me.btnLoadSettings)
        Me.gbMusepaxx.Location = New System.Drawing.Point(8, 8)
        Me.gbMusepaxx.Name = "gbMusepaxx"
        Me.gbMusepaxx.Size = New System.Drawing.Size(336, 88)
        Me.gbMusepaxx.TabIndex = 12
        Me.gbMusepaxx.TabStop = False
        Me.gbMusepaxx.Text = "Musepaxx"
        '
        'btnSaveSettings
        '
        Me.btnSaveSettings.Location = New System.Drawing.Point(104, 56)
        Me.btnSaveSettings.Name = "btnSaveSettings"
        Me.btnSaveSettings.Size = New System.Drawing.Size(80, 23)
        Me.btnSaveSettings.TabIndex = 14
        Me.btnSaveSettings.Text = "Save settings"
        '
        'btnMusepaxx
        '
        Me.btnMusepaxx.Location = New System.Drawing.Point(248, 24)
        Me.btnMusepaxx.Name = "btnMusepaxx"
        Me.btnMusepaxx.Size = New System.Drawing.Size(72, 23)
        Me.btnMusepaxx.TabIndex = 1
        Me.btnMusepaxx.Text = "Musepaxx"
        '
        'txtMusepaxx
        '
        Me.txtMusepaxx.Location = New System.Drawing.Point(16, 24)
        Me.txtMusepaxx.Name = "txtMusepaxx"
        Me.txtMusepaxx.Size = New System.Drawing.Size(224, 20)
        Me.txtMusepaxx.TabIndex = 0
        Me.txtMusepaxx.Text = ""
        '
        'btnLoadSettings
        '
        Me.btnLoadSettings.Location = New System.Drawing.Point(16, 56)
        Me.btnLoadSettings.Name = "btnLoadSettings"
        Me.btnLoadSettings.Size = New System.Drawing.Size(80, 23)
        Me.btnLoadSettings.TabIndex = 13
        Me.btnLoadSettings.Text = "Load settings"
        '
        'chDir
        '
        Me.chDir.Location = New System.Drawing.Point(8, 488)
        Me.chDir.Name = "chDir"
        Me.chDir.Size = New System.Drawing.Size(128, 24)
        Me.chDir.TabIndex = 13
        Me.chDir.Text = "Output to this folder:"
        '
        'txtDir
        '
        Me.txtDir.Enabled = False
        Me.txtDir.Location = New System.Drawing.Point(136, 488)
        Me.txtDir.Name = "txtDir"
        Me.txtDir.Size = New System.Drawing.Size(208, 20)
        Me.txtDir.TabIndex = 14
        Me.txtDir.Text = ""
        '
        'MusepaxxGUI
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(352, 516)
        Me.Controls.Add(Me.txtDir)
        Me.Controls.Add(Me.chDir)
        Me.Controls.Add(Me.gbMusepaxx)
        Me.Controls.Add(Me.Label3)
        Me.Controls.Add(Me.gbEncoder)
        Me.Controls.Add(Me.gbDecoder)
        Me.Controls.Add(Me.lbFiles)
        Me.Controls.Add(Me.btnTrans)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.MaximizeBox = False
        Me.Name = "MusepaxxGUI"
        Me.Text = " Musepaxx GUI 0.1"
        Me.gbDecoder.ResumeLayout(False)
        Me.gbEncoder.ResumeLayout(False)
        Me.gbMusepaxx.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub btnDec_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDec.Click
        'Writing of the decoder-location into txtDecLoc
        'with the std file-dialog
        Dim decOpen As New OpenFileDialog

        decOpen.Filter = "Executeable (*.exe)|*.exe"
        decOpen.RestoreDirectory = True

        If decOpen.ShowDialog = DialogResult.OK Then
            txtDecLoc.Text = decOpen.FileName
        End If
    End Sub

    Private Sub btnEnc_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEnc.Click
        'Writing of the encoder-location into txtEncLoc
        'with the std file-dialog
        Dim encOpen As New OpenFileDialog

        encOpen.Filter = "Executeable (*.exe)|*.exe"
        encOpen.RestoreDirectory = True

        If encOpen.ShowDialog = DialogResult.OK Then
            txtEncLoc.Text = encOpen.FileName
        End If
    End Sub

    Private Sub btnTrans_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTrans.Click
        'Saving of the Musepaxx.cfg in case it wasn't saved before
        Dim SaveStream As StreamWriter = New StreamWriter(CurDir() & "\Musepaxx.cfg", False, System.Text.Encoding.ASCII)
        SaveStream.WriteLine("decoder_location = " & txtDecLoc.Text)
        SaveStream.WriteLine("decoder_settings = " & txtDecSet.Text)
        SaveStream.WriteLine("decoder_extension = " & txtDecExt.Text)
        SaveStream.WriteLine("encoder_location = " & txtEncLoc.Text)
        SaveStream.WriteLine("encoder_settings = " & txtEncSet.Text)
        SaveStream.WriteLine("encoder_extension = " & txtEncExt.Text)
        SaveStream.Close()

        'Calling of Musepaxx.exe
        Dim FileBuffer As String
        If lbFiles.Items.Count > 0 Then
            Me.WindowState = FormWindowState.Minimized
            While lbFiles.Items.Count > 0
                FileBuffer = lbFiles.Items.Item(0)
                If (chDir.Checked = False) Then
                    Shell(txtMusepaxx.Text & " " & _
                        Chr(34) & lbFiles.Items.Item(0) & Chr(34) & " " & _
                        Chr(34) & FileBuffer.Substring(0, FileBuffer.Length - 4) & txtEncExt.Text & Chr(34), AppWinStyle.NormalFocus, True)
                Else
                    Dim i As Integer
                    i = 3
                    Do
                        i = i + 1
                    Loop Until (FileBuffer.Chars(FileBuffer.Length - i) = "\")
                    If FileBuffer.Chars(FileBuffer.Length - i) = "\" Then
                        FileBuffer = txtDir.Text & FileBuffer.Substring(FileBuffer.Length - i)
                    End If
                    Shell(txtMusepaxx.Text & " " & _
                        Chr(34) & lbFiles.Items.Item(0) & Chr(34) & " " & _
                        Chr(34) & FileBuffer.Substring(0, FileBuffer.Length - 4) & txtEncExt.Text & Chr(34), AppWinStyle.NormalFocus, True)
                End If
                lbFiles.Items.RemoveAt(0)
            End While
            Me.WindowState = FormWindowState.Normal
        End If
    End Sub

    Private Sub lbFiles_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles lbFiles.DragEnter
        'Event triggerd if you drag something onto the Listbox
        'but the mouse-button is still pressed

        'Check if it's a file that's dragged onto the box
        If (e.Data.GetDataPresent(DataFormats.FileDrop)) Then
            e.Effect = DragDropEffects.Copy
        Else
            e.Effect = DragDropEffects.None
        End If
    End Sub

    Private Sub lbFiles_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles lbFiles.DragDrop
        Dim i As IEnumerator
        Dim DragDropData As Object
        Dim FileNameBuffer As String

        'get the Drag&Drop-data and load it into a array
        DragDropData = e.Data.GetData(DataFormats.FileDrop)
        i = DragDropData.GetEnumerator

        'writing of the data into the listbox
        While i.MoveNext
            FileNameBuffer = i.Current()
            If (FileNameBuffer.EndsWith(txtDecExt.Text)) Then
                lbFiles.Items.Add(FileNameBuffer)
            End If
        End While
    End Sub

    Private Sub btnMusepaxx_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMusepaxx.Click
        'Writing of the Musepaxx-location into txtMusepaxx
        'with the std file-dialog
        Dim MusepaxxOpen As New OpenFileDialog

        MusepaxxOpen.InitialDirectory = CurDir()
        MusepaxxOpen.Filter = "Executeable (*.exe)|*.exe"
        MusepaxxOpen.RestoreDirectory = True

        If MusepaxxOpen.ShowDialog = DialogResult.OK Then
            txtMusepaxx.Text = MusepaxxOpen.FileName
        End If
    End Sub

    Private Sub btnLoadSettings_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadSettings.Click
        'Loading of the config-file and writing of the items in the textboxes
        'a std-dialog is used for the location
        Dim SettingsOpen As New OpenFileDialog

        SettingsOpen.Filter = "Musepaxx Config (*.cfg)|*.cfg"
        SettingsOpen.RestoreDirectory = True
        SettingsOpen.Multiselect = False

        If SettingsOpen.ShowDialog = DialogResult.OK Then
            Dim LineBuffer As String
            Dim FileNum As Integer
            FileNum = FreeFile()
            FileOpen(FileNum, SettingsOpen.FileName, OpenMode.Input, OpenAccess.Read)
            While Not EOF(FileNum)
                LineBuffer = LineInput(FileNum)
                If (LineBuffer.Chars(0) = "d") Then
                    If (LineBuffer.Substring(0, 16) = "decoder_location") Then
                        txtDecLoc.Text = LineBuffer.Substring(19)
                    ElseIf (LineBuffer.Substring(0, 16) = "decoder_settings") Then
                        txtDecSet.Text = LineBuffer.Substring(19)
                    ElseIf (LineBuffer.Substring(0, 17) = "decoder_extension") Then
                        txtDecExt.Text = LineBuffer.Substring(20)
                    End If
                ElseIf (LineBuffer.Chars(0) = "e") Then
                    If (LineBuffer.Substring(0, 16) = "encoder_location") Then
                        txtEncLoc.Text = LineBuffer.Substring(19)
                    ElseIf (LineBuffer.Substring(0, 16) = "encoder_settings") Then
                        txtEncSet.Text = LineBuffer.Substring(19)
                    ElseIf (LineBuffer.Substring(0, 17) = "encoder_extension") Then
                        txtEncExt.Text = LineBuffer.Substring(20)
                    End If
                End If
            End While
            FileClose(FileNum)
        End If
    End Sub

    Private Sub btnSaveSettings_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveSettings.Click
        'Writing of the config-file
        'a std-dialog is used for the location
        Dim SettingsSave As New SaveFileDialog

        SettingsSave.Filter = "Musepaxx Config (*.cfg)|*.cfg"
        SettingsSave.RestoreDirectory = True

        If SettingsSave.ShowDialog = DialogResult.OK Then
            Dim SaveStream As StreamWriter = New StreamWriter(SettingsSave.FileName, False, System.Text.Encoding.ASCII)
            SaveStream.WriteLine("decoder_location = " & txtDecLoc.Text)
            SaveStream.WriteLine("decoder_settings = " & txtDecSet.Text)
            SaveStream.WriteLine("decoder_extension = " & txtDecExt.Text)
            SaveStream.WriteLine("encoder_location = " & txtEncLoc.Text)
            SaveStream.WriteLine("encoder_settings = " & txtEncSet.Text)
            SaveStream.WriteLine("encoder_extension = " & txtEncExt.Text)
            SaveStream.Close()
        End If
    End Sub

    Private Sub MusepaxxGUI_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'check if Musepaxx .exe and .cfg exist
        'writing of the .exe location in the textbox and
        'writing of the settings in the textboxes
        If (File.Exists("Musepaxx.exe") = True) Then
            txtMusepaxx.Text = CurDir() & "\Musepaxx.exe"
        End If
        If (File.Exists("Musepaxx.cfg") = True) Then
            Dim LineBuffer As String
            Dim FileNum As Integer
            FileNum = FreeFile()
            FileOpen(FileNum, "Musepaxx.cfg", OpenMode.Input, OpenAccess.Read)
            While Not EOF(FileNum)
                LineBuffer = LineInput(FileNum)
                If (LineBuffer.Chars(0) = "d") Then
                    If (LineBuffer.Substring(0, 16) = "decoder_location") Then
                        txtDecLoc.Text = LineBuffer.Substring(19)
                    ElseIf (LineBuffer.Substring(0, 16) = "decoder_settings") Then
                        txtDecSet.Text = LineBuffer.Substring(19)
                    ElseIf (LineBuffer.Substring(0, 17) = "decoder_extension") Then
                        txtDecExt.Text = LineBuffer.Substring(20)
                    End If
                ElseIf (LineBuffer.Chars(0) = "e") Then
                    If (LineBuffer.Substring(0, 16) = "encoder_location") Then
                        txtEncLoc.Text = LineBuffer.Substring(19)
                    ElseIf (LineBuffer.Substring(0, 16) = "encoder_settings") Then
                        txtEncSet.Text = LineBuffer.Substring(19)
                    ElseIf (LineBuffer.Substring(0, 17) = "encoder_extension") Then
                        txtEncExt.Text = LineBuffer.Substring(20)
                    End If
                End If
            End While
            FileClose(FileNum)
        End If
    End Sub

    Private Sub chDir_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chDir.CheckedChanged
        'enable txtDir if the checkbox is checked and popup a dialog for the loacation
        If txtDir.Enabled = False Then
            txtDir.Enabled = True
            Dim SelectDir As New FolderBrowserDialog
            If (SelectDir.ShowDialog() = DialogResult.OK) Then
                txtDir.Text = SelectDir.SelectedPath
            End If
        Else
            txtDir.Enabled = False
        End If
    End Sub
End Class
